<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 32
nchnls = 2
0dbfs = 1

/* use widgets to control csound
    (modification of 09) */

instr Analyze_and_trigger

 ;get input channel 1
 aMic inch 1 
 
 ;get rms
 kRms rms aMic

 ;show peak and rms 
 gkTrig metro 10
 kPeak max_k aMic, gkTrig, 1
 outvalue "input_db", dbamp(kPeak)
 outvalue "input_rms", dbamp(kRms)
 
 ;get value for threshold from slider widget
 kThreshDb invalue "threshdb"
 kThresh = ampdb(kThreshDb)
 
 ;look for thresh crossing and trigger beep
 kPause init 0 ;sec
 kPreviousRms init 0
 if kRms > kThresh && kPreviousRms <= kThresh && kPause <= 0 then
  event "i", "Beep", 0, .1
  kPause = 0.1 ;reset pause
 endif
 kPause -= ksmps/sr ;count backwards

endin
schedule "Analyze_and_trigger", 0, 999

instr Beep

 aBeep poscil 0.2, random:i(400,800)
 aEnv linen aBeep, 0, p3, p3
 aL, aR pan2 aEnv, random:i(0,1)
 out aL, aR

endin

instr Show_sum

 aL, aR monitor
 kPeak_L max_k aL, gkTrig, 1
 kPeak_R max_k aR, gkTrig, 1
 outvalue "out_L", dbamp(kPeak_L)
 outvalue "out_R", dbamp(kPeak_R)

endin
schedule "Show_sum", 0, 999

</CsInstruments>
<CsScore>

</CsScore>
</CsoundSynthesizer>
<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>691</x>
 <y>316</y>
 <width>648</width>
 <height>386</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="nobackground">
  <r>255</r>
  <g>255</g>
  <b>255</b>
 </bgcolor>
 <bsbObject version="2" type="BSBController">
  <objectName>input_db</objectName>
  <x>42</x>
  <y>54</y>
  <width>385</width>
  <height>23</height>
  <uuid>{58aeae1b-9504-45fe-b52c-cd9f0d28acc7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>input_db</objectName2>
  <xMin>-60.00000000</xMin>
  <xMax>0.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>-52.20573603</xValue>
  <yValue>-52.20573603</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>0</r>
   <g>234</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>input_db</objectName>
  <x>435</x>
  <y>53</y>
  <width>98</width>
  <height>29</height>
  <uuid>{eca41519-d4e7-47c2-a2fc-c4ac5f3ed6bf}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>-52.206</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>42</x>
  <y>20</y>
  <width>303</width>
  <height>31</height>
  <uuid>{9ae77f2d-f1e1-46aa-88d1-15449a929acb}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>input (dB)</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>41</x>
  <y>151</y>
  <width>303</width>
  <height>31</height>
  <uuid>{9a01d309-c10b-409a-999f-2b741cb504a2}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>threshold to trigger beep (dB)</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBHSlider">
  <objectName>threshdb</objectName>
  <x>41</x>
  <y>186</y>
  <width>306</width>
  <height>30</height>
  <uuid>{7ea65da8-35cb-45c9-a139-74afd7a90c62}</uuid>
  <visible>true</visible>
  <midichan>1</midichan>
  <midicc>8</midicc>
  <minimum>-60.00000000</minimum>
  <maximum>0.00000000</maximum>
  <value>-19.84251969</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>threshdb</objectName>
  <x>351</x>
  <y>186</y>
  <width>98</width>
  <height>29</height>
  <uuid>{a2a6a14d-176c-45ad-b7a8-c0c99dc8203a}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>-19.843</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>out_L</objectName>
  <x>39</x>
  <y>271</y>
  <width>385</width>
  <height>23</height>
  <uuid>{d6f46fe9-0fa6-4382-9424-2b5358493da7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>out_L</objectName2>
  <xMin>-60.00000000</xMin>
  <xMax>0.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>-inf</xValue>
  <yValue>-inf</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>0</r>
   <g>234</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>out_L</objectName>
  <x>432</x>
  <y>270</y>
  <width>98</width>
  <height>29</height>
  <uuid>{c63d8d1f-c438-4a4d-949c-f0b80c78f787}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>-inf</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>39</x>
  <y>235</y>
  <width>303</width>
  <height>31</height>
  <uuid>{de42e5c2-86a1-4ef2-a480-8a0c65067f6f}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>output (dB)</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>out_R</objectName>
  <x>39</x>
  <y>307</y>
  <width>385</width>
  <height>23</height>
  <uuid>{cec89423-84b2-4844-8adb-1fa7261ce7e8}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>out_R</objectName2>
  <xMin>-60.00000000</xMin>
  <xMax>0.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>-inf</xValue>
  <yValue>-inf</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>0</r>
   <g>234</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>out_R</objectName>
  <x>432</x>
  <y>303</y>
  <width>98</width>
  <height>29</height>
  <uuid>{47ca16bd-7248-4e9c-863c-2f5b29a1ad26}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>-inf</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>input_rms</objectName>
  <x>40</x>
  <y>118</y>
  <width>385</width>
  <height>23</height>
  <uuid>{16c38c30-05eb-48c2-9991-edb8e59430fd}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>input_rms</objectName2>
  <xMin>-60.00000000</xMin>
  <xMax>0.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>-53.62963456</xValue>
  <yValue>-53.62963456</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>0</r>
   <g>234</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>input_rms</objectName>
  <x>433</x>
  <y>117</y>
  <width>98</width>
  <height>29</height>
  <uuid>{dee1bde2-b6f9-49eb-bb0e-88ef0e99d2c7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>-53.630</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>40</x>
  <y>84</y>
  <width>303</width>
  <height>31</height>
  <uuid>{4e52284c-18eb-442a-89fe-1c763ac88dee}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>rms (dB)</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
