<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 32
nchnls = 2
0dbfs = 1

;user defined opcode (UDO) for nicer signal view
opcode CsQtMeter, 0, SSak
 S_chan_sig, S_chan_over, aSig, kTrig	xin
 iDbRange = 60 ;shows 60 dB
 iHoldTim = 1 ;seconds to "hold the red light"
 kOn init 0
 kTim init 0
 kStart init 0
 kEnd init 0
 kMax max_k aSig, kTrig, 1
 if kTrig == 1 then
  outvalue S_chan_sig, (iDbRange + dbfsamp(kMax)) / iDbRange
  if kOn == 0 && kMax > 1 then
   kTim = 0
   kEnd = iHoldTim
   outvalue S_chan_over, k(1)
   kOn = 1
  endif
  if kOn == 1 && kTim > kEnd then
   outvalue S_chan_over, k(0)
   kOn =	0
  endif
 endif
 kTim += ksmps/sr
endop


instr ChooseAudio

 ;0 = live input, 1 = fox, 2 = viola
 kWhich invalue "which"
 
 ;different inputs
 aMic inch 1
 aFox diskin "fox.wav", 1, 0, 1
 aViola diskin "Viola.aiff", 1, 0, 1
 
 ;write one of them as global audio 
 if kWhich == 0 then
  gaIn = aMic
 elseif kWhich == 1 then
  gaIn = aFox
 else
  gaIn = aViola
 endif
 
 ;show input
 gkTrigDisp metro 10
 CsQtMeter "in", "in_over", gaIn, gkTrigDisp 

endin
schedule "ChooseAudio", 0, 99999

instr SpectralShift

 ;settings for FFT
 iFFTsize = 512 ;depending on the input
 iOverlap = iFFTsize / 4
 iWinSize = iFFTsize
 iWinType = 1 ;von Hann
 
 ;FFT (resulting in a f-signal
 fInput pvsanal gaIn, iFFTsize, iOverlap, iWinSize, iWinType
 
 ;doing anything here: shift
 kShiftFreq invalue "shiftfreq"
 kLowestFreq invalue "lowestfreq"
 fShift pvshift fInput, kShiftFreq, kLowestFreq

 ;and then back to time domain
 aOut pvsynth fShift
 
 ;apply volume and output
 kVolDb invalue "master_vol"
 kVolDb port kVolDb, .01 ;smooth
 out aOut*ampdb(kVolDb), aOut*ampdb(kVolDb)
 
endin
schedule "SpectralShift", 0, 99999

instr Monitor

 aL, aR monitor
 CsQtMeter "out_L", "out_L_over", aL, gkTrigDisp
 CsQtMeter "out_R", "out_R_over", aR, gkTrigDisp

endin
schedule "Monitor", 0, 99999


</CsInstruments>
<CsScore>

</CsScore>
</CsoundSynthesizer>
<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>599</x>
 <y>222</y>
 <width>648</width>
 <height>296</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>230</r>
  <g>181</g>
  <b>107</b>
 </bgcolor>
 <bsbObject version="2" type="BSBDropdown">
  <objectName>which</objectName>
  <x>37</x>
  <y>51</y>
  <width>80</width>
  <height>30</height>
  <uuid>{f1359ce0-80eb-4e01-a924-8ed1ff9b9fce}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <bsbDropdownItemList>
   <bsbDropdownItem>
    <name>live input</name>
    <value>0</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>fox</name>
    <value>1</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>viola</name>
    <value>2</value>
    <stringvalue/>
   </bsbDropdownItem>
  </bsbDropdownItemList>
  <selectedIndex>2</selectedIndex>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>23</x>
  <y>18</y>
  <width>124</width>
  <height>30</height>
  <uuid>{dd2c7398-dda0-47e9-86db-d45a558a5fe0}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Choose Input</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>in</objectName>
  <x>176</x>
  <y>34</y>
  <width>400</width>
  <height>30</height>
  <uuid>{e53212e6-26b1-4255-8dd1-29982a5f376d}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>in</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.46218430</xValue>
  <yValue>0.46218430</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>0</r>
   <g>234</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>in_over</objectName>
  <x>576</x>
  <y>34</y>
  <width>30</width>
  <height>30</height>
  <uuid>{1ac98e63-ff22-42c2-b9b4-211a3387ff55}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>in_over</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.00000000</xValue>
  <yValue>0.00000000</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>196</r>
   <g>14</g>
   <b>12</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>out_L</objectName>
  <x>173</x>
  <y>180</y>
  <width>400</width>
  <height>30</height>
  <uuid>{ac88662d-99ed-4d4c-8806-63932bcef9ee}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>out_L</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.30582643</xValue>
  <yValue>0.30582643</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>0</r>
   <g>234</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>out_L_over</objectName>
  <x>573</x>
  <y>180</y>
  <width>30</width>
  <height>30</height>
  <uuid>{222a8781-08d7-4dc5-910b-7474b945eb31}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>out_L_over</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.00000000</xValue>
  <yValue>0.00000000</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>196</r>
   <g>14</g>
   <b>12</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>out_R</objectName>
  <x>173</x>
  <y>216</y>
  <width>400</width>
  <height>30</height>
  <uuid>{69adc61c-b7a4-4cc3-8d73-8089cec5bd22}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>out_R</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.30582643</xValue>
  <yValue>0.30582643</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>0</r>
   <g>234</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>out_R_over</objectName>
  <x>573</x>
  <y>216</y>
  <width>30</width>
  <height>30</height>
  <uuid>{32be6800-d838-404e-8bf0-f2ccdd47b0f3}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>out_R_over</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.00000000</xValue>
  <yValue>0.00000000</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>196</r>
   <g>14</g>
   <b>12</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBKnob">
  <objectName>master_vol</objectName>
  <x>39</x>
  <y>95</y>
  <width>80</width>
  <height>80</height>
  <uuid>{ef74c409-c517-49bc-a007-5d751c56f9eb}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>-30.00000000</minimum>
  <maximum>30.00000000</maximum>
  <value>-7.80000000</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>0.01000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>8</x>
  <y>178</y>
  <width>140</width>
  <height>34</height>
  <uuid>{d263a5e4-d3d3-4cf1-af94-434ad2ff9ec4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Volume</label>
  <alignment>center</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>188</x>
  <y>71</y>
  <width>150</width>
  <height>33</height>
  <uuid>{35923aa0-f82d-4e4d-9677-7bd04f1ccfba}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Shift Freq (Hz)</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>372</x>
  <y>70</y>
  <width>180</width>
  <height>33</height>
  <uuid>{f859b0e9-6dd0-428d-8bf8-4de492dda15e}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Lowest Freq (Hz)</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBSpinBox">
  <objectName>shiftfreq</objectName>
  <x>220</x>
  <y>109</y>
  <width>102</width>
  <height>34</height>
  <uuid>{855abec5-9c69-4938-bf50-df5341440c87}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <alignment>right</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <resolution>0.00100000</resolution>
  <minimum>-1e+12</minimum>
  <maximum>1e+12</maximum>
  <randomizable group="0">false</randomizable>
  <value>100</value>
 </bsbObject>
 <bsbObject version="2" type="BSBSpinBox">
  <objectName>lowestfreq</objectName>
  <x>413</x>
  <y>109</y>
  <width>102</width>
  <height>34</height>
  <uuid>{8cae9842-7a67-46ab-b933-3171dc443ba5}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <alignment>right</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <resolution>0.00100000</resolution>
  <minimum>-1e+12</minimum>
  <maximum>1e+12</maximum>
  <randomizable group="0">false</randomizable>
  <value>1000</value>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
